﻿/**
ﾈﾑぃ

Version
	1.00β14:

History:
	<ul>
		<li>機能追加/実装/変更/停止/廃止: [F]eatures</li>
		<li>バグ修正/告知: [B]ug</li>
		<li>プログラム的な変更(なんだこれ): [P]rogram</li>
		<li>ソース上の変更: [S]ource</li>
		<li>↑以外のこと: [@]</li>
	</ul>

	1.00β14, 2008/09/01:
		[F] アイテム設定時にアドレスが環境変数を含んでいる場合に登録できない不具合を修正。
		[P] アイテム設定時にD&Dした時の挙動を変更。ポインタがアイテムリストの上にあれば新規作成、なければ通常の設定。
		[B] アイテムの作業フォルダに環境変数が含まれていた場合にそのアイテムを実行できないバグを修正。
		[F] グループ設定の項目ダブルクリックを無視するように修正。
		[S] 大部分のstringからTextへの置き換え運動開始。修正箇所が多いので該当部分へのHistory記述無し。diffでもしてくれ。
	
	1.00β13, 2009/08/29:
		[@] 今バージョンからHistoryに修正箇所の目印を追加するように心に決めた。
		[F] アイテム設定においてショートカットファイル(*.lnk)に対応。
		[P] D&D処理を一部実装。
		[P] バージョン情報ダイアログにユーザー環境ではなく作者の環境を表示するように変更。
		[S] Historyがあまりにも残念だったのを修正。

	1.00β12, 2009/08/27:
		設定画面における「OK」と「CANCEL」の位置を入れ替え。
		メインウィンドウがバー状態でもタイトルバーD&Dによる移動が許可されていたバグの修正。
		メインウィンドウがバー状態の際に特定方向のみへサイズ変更するようにヒットテスト修正。
		アイテムの設定で「アドレスに合わせる」を実装。

	1.00β11, 2009/08/24:
		アイコン取得時にアドレスがDLLだった場合にアイコンインデックスが無視される不具合を修正。
		アイコン入力欄を入力可能に変更。
		アイテムメニューにおいて拡張子無しのファイル(と.無しフォルダ)が存在する場合に落ちるバグを修正。
		バージョン情報ダイアログ暫定実装。
		フォルダオープン時にエクスプローラ表示が無視されていた不具合を修正。
	
	1.00β10, 2009/08/19:
		公開。
*/
module nemuxi.nemuxi;

version(build) {
	pragma(build_def, "EXETYPE NT");
	pragma(build_def, "SUBSYSTEM WINDOWS,5.0");
}

import win32.windows;
import win32.commctrl;

import nemuxi.base;
import nemuxi.system.application;
//import nemuxi.negui.proc.nemuxiwnd.nemuxiwnd;
import nemuxi.gui.window.nemuxiwindow.nemuxiwindow;
import nemuxi.negui.window.dialog.system;
//import nemuxi.negui.proc.commandwnd.commandwnd;
import nemuxi.gui.window.dialog.exceptiondialog.exceptiondialog;


/**
History:
	1.00β12:
		設定ファイルの書き込みタイミングを変更。

	1.00β11:
		例外catchの悪足掻きを追加。
*/
int main(string[] args) {
	//Logger.flag=true;
	Logger.flag=StaticData.logEnable;
	
	try {
		auto hWnd=new NemuxiWindow(MakeApplication());
		
		try {
			scope(success) SaveApplication(hWnd.application);
			Logger.write("args -> %s", args);
			hWnd.dataLoad;
			return hWnd.execute();
		} catch(NemuxiException e) {
			Logger.write(e);
			ShowExceptionDialog(hWnd, e);
			return e.code;
		}
	} catch (Throwable e) {
		Logger.write(e);
		ShowExceptionDialog(null, e);
		return -1;
	} catch(Object o) {
		Logger.write(o);
		MessageDialog.show(o.toString.toText);
		return -2;
	}

}

